package com.muzhi.lingai.controller;

import com.muzhi.lingai.service.DingOaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;


@Api(description = "钉钉")
@RestController
@RequestMapping("/dingservice")
//@CrossOrigin//解决跨域问题
public class DingOaController {

    @Autowired
    private DingOaService dingOaService;

    //获取售后宝接口授权码
    @ApiOperation(value = "获取售后宝接口授权码")
    @GetMapping("getShouhoubaoAccessToken")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public String getWangdiantongStocks(){

        String shouhoubaoAccessToken = dingOaService.getShouhoubaoAccessToken();
        return shouhoubaoAccessToken;
    }

    //同步客户信息至售后宝
    @ApiOperation(value = "同步客户信息至售后宝")
    @PostMapping("tongbuKehu")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public String tongbuKehu(String khbh,String khmc,String khlxrList,String khlxrdhList,
                             String khlxrzwList,String khdz,
                             String userid,String khfzrxm,String htqydw){

        String s = dingOaService.tongbuKehu(khbh, khmc, khlxrList, khlxrdhList, khlxrzwList, khdz, userid, khfzrxm, htqydw);
        return s;
    }

    //创建售后宝工单
    @ApiOperation(value = "创建售后宝工单")
    @PostMapping("createGongdan")
    public String createGongdan(String khbh,String khmc,String khdz,String khlxr,String khlxrdh,String gdid,String gdmc,
                                String cpmcList,String cpppList,String cpxhList,String cpazwzList,
                                String sdqkList,String azrq){

        String s = dingOaService.createGongdan(khbh, khmc, khdz, khlxr, khlxrdh, gdid, gdmc,
                cpmcList, cpppList, cpxhList, cpazwzList, sdqkList, azrq);
        return s;
    }
}