package com.muzhi.lingai.APITest;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkyida_1_0.models.SearchFormDatasResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.muzhi.lingai.service.AccessTokenService;
import lombok.extern.slf4j.Slf4j;
import okhttp3.*;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.lang.StringEscapeUtils;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

@SpringBootTest
@Slf4j
public class Test1 {

    @Autowired
    private AccessTokenService accessTokenService;

    @Test
    public void panduan(){
        //判断日期是否为周六周日
        String date = "2022-10-08 00:00:00";
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date date1 = null;
        try {
            date1 = format.parse(date);
            System.out.println("date1：" + date1);
        }catch (Exception e){
            e.printStackTrace();
        }
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date1);

        if (calendar.get(Calendar.DAY_OF_WEEK)==Calendar.SATURDAY||calendar.get(Calendar.DAY_OF_WEEK)==Calendar.SUNDAY){
            System.out.println("当前日期为周六周日！");
        }else {
            System.out.println("当前日期为工作日");
        }
    }

    @Test
    public void date(){
        int dkcs = 5;
        int ccts = 0;

        dkcs = dkcs/2;
        int dkcsLast = (int)dkcs;


        if (dkcs > 0){
            //实际出差天数
            ccts = ccts + dkcsLast;
            System.out.println("实际出差天数：" + ccts);
        }

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        long startLong = new Long("1670342400000");
        //将时间戳转换为时间
        Date startDate = new Date(startLong);
        System.out.println("出差开始时间（时间型）：" + startDate);
        //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
        String startString = simpleDateFormat.format(startDate);
        System.out.println("出差开始时间（时间样式）：" + startString);

        long endLong = new Long("1670428800000");
        //将时间戳转换为时间
        Date endDate = new Date(endLong);
        System.out.println("出差结束时间（时间型）：" + endDate);
        //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
        String endString = simpleDateFormat.format(endDate);
        System.out.println("出差结束时间（时间样式）：" + endString);

        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(endDate);
        //后面一天
        calendar1.add(Calendar.DAY_OF_MONTH,1);
        calendar1.set(Calendar.HOUR_OF_DAY,0);
        calendar1.set(Calendar.MINUTE,0);
        calendar1.set(Calendar.SECOND,0);
        calendar1.set(Calendar.MILLISECOND,0);
        String time1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar1.getTime());
        System.out.println("出差结束时间后面一天零点：" + time1);

        DateTime lastDateTime = DateUtil.parse(time1);
        System.out.println("出差结束时间后面一天（时间型）：" + lastDateTime);

        //获取当天前一天的零点零分零秒
        Date Date = new Date(System.currentTimeMillis());
        System.out.println("当前时间：" + Date);
        String dateNowString = simpleDateFormat.format(Date);
        System.out.println("当前时间（时间样式）：" + dateNowString);

        Calendar calendar = Calendar.getInstance();
        calendar.setTime(Date);
        //前一天
        calendar.add(Calendar.DAY_OF_MONTH,-1);
        calendar.set(Calendar.HOUR_OF_DAY,0);
        calendar.set(Calendar.MINUTE,0);
        calendar.set(Calendar.SECOND,0);
        calendar.set(Calendar.MILLISECOND,0);
        String time = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
        System.out.println("前一天零点：" + time);

        Calendar calendar111 = Calendar.getInstance();
        calendar111.setTime(Date);
        //前一个月第一天
        calendar111.add(Calendar.MONTH,-1);
        calendar111.set(Calendar.DAY_OF_MONTH,1);
        calendar111.set(Calendar.HOUR_OF_DAY,0);
        calendar111.set(Calendar.MINUTE,0);
        calendar111.set(Calendar.SECOND,0);
        calendar111.set(Calendar.MILLISECOND,0);
        String FORMtime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar111.getTime());
        System.out.println("前一个月第一天零点：" + FORMtime);

        Calendar calendar222 = Calendar.getInstance();
        int month222 = calendar222.get(Calendar.MONTH);
        //前一个月最后一天
        calendar222.set(Calendar.MONTH,month222-1);
        calendar222.set(Calendar.DAY_OF_MONTH,calendar222.getActualMaximum(Calendar.DAY_OF_MONTH));
        calendar222.set(Calendar.HOUR_OF_DAY,0);
        calendar222.set(Calendar.MINUTE,0);
        calendar222.set(Calendar.SECOND,0);
        calendar222.set(Calendar.MILLISECOND,0);
        String TOtime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar222.getTime());
        System.out.println("前一个月最后一天零点：" + TOtime);
    }

    //MD5加密
    @Test
    public void MD5(){

        /*明文
        * timestamp毫秒级时间戳
        * */
        //当前时间的时间戳
        long timeMillis = System.currentTimeMillis();
        String timestamp = String.valueOf(timeMillis);
        log.info("当前时间的时间戳（毫秒级）：" + timestamp);

        /*秘钥
         * AppSecret应用秘钥
         * */
        String AppSecret = "f7585e1f2c4c25682f407af23b7ff7d5f21f4f9e3715c294";

        //加密后的字符串
        String encodeStr= DigestUtils.md5Hex(AppSecret + "_" + timestamp);
        log.info("MD5加密后的字符串encodeStr：" + encodeStr);

        Map map = new HashMap();
        map.put("appKey","shbqv00tso4dg5kcjz");
        map.put("timestamp",timestamp);
        map.put("verifyCode",encodeStr);
        String parmsStr = JSON.toJSONString(map);
        log.info("封装秘钥参数parmsStr：" + parmsStr);

        //售后宝【接口授权】
        //授权码
        String access_token = null;
        //失效时间
        String expire_time = null;
        try {
            OkHttpClient client = new OkHttpClient().newBuilder()
                    .build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, parmsStr);
            Request request = new Request.Builder()
                    .url("https://oapi.shb.ltd/service/auth/get_access_token")
                    .method("POST", body)
                    .addHeader("Content-Type", "application/json")
                    .addHeader("Cookie", "acw_tc=0a45662a16728986832314856e80f39124201b89184960430078b3ebfda740")
                    .build();

            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【接口授权】返回信息：" + responseBody);
            String substring1 = responseBody.substring(1, responseBody.length() - 1);
            log.info("去除首尾双引号后的返回信息：" + substring1);
            String substring2 = substring1.replaceAll("\\\\", "");
            log.info("去除转义字符后的返回信息：" + substring2);

            JSONObject jsonObject = JSON.parseObject(substring2);
            JSONObject data = jsonObject.getJSONObject("data");
            //授权码
            access_token = data.getString("access_token");
            //失效时间
            expire_time = data.getString("expire_time");
        }catch (Exception e){
            e.printStackTrace();
        }

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        long endLong = new Long(expire_time);
        //将时间戳转换为时间
        Date endDate = new Date(endLong);
        System.out.println("授权码失效时间（时间型）：" + endDate);
        //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
        String endString = simpleDateFormat.format(endDate);
        System.out.println("授权码失效时间（时间样式）：" + endString);
        log.info("【授权码】：" + access_token + "【失效时间】：" + endString);
    }

    //【客户列表】
    @Test
    public void getKehuList(){
        Map map = new HashMap();
        map.put("pageSize",50);
        map.put("pageNum",1);
        map.put("keyword","KH20230607020507345");

        String jsonString = JSON.toJSONString(map);
        System.out.println("封装的客户列表查询接口条件参数：" + jsonString);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, jsonString);
        Request request = new Request.Builder()
                .url("https://oapi.shb.ltd/service/customer/get_customers?accessToken=4da6f063-5083-481f-8e0a-be59d41eea40")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .build();

        try {
            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【客户列表】返回信息：" + responseBody);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    //根据客户编号查询售后宝客户是否存在
    @Test
    public void getKehuBoolean(){

        //售后宝授权码
        String shouhoubaoAccessToken = "46998202-77f4-4943-a2a3-61a3a96a0959";
        //客户编号
        String khbh = "KH001";

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://oapi.shb.ltd/service/customer/get_customer_customerNo?accessToken="+shouhoubaoAccessToken+
                        "&customerNo="+khbh)
                .method("GET", null)
                .build();

        boolean flag = false;
        try {
            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【客户详情】返回信息：" + responseBody);
            String substring1 = responseBody.substring(1, responseBody.length() - 1);
            log.info("去除首尾双引号后的返回信息：" + substring1);
            String substring2 = substring1.replaceAll("\\\\", "");
            log.info("去除转义字符后的返回信息：" + substring2);

            JSONObject jsonObject = JSON.parseObject(substring2);
            Integer errorCode = jsonObject.getInteger("errorCode");
            if (errorCode == 0){
                System.out.println("当前客户在售后宝【已存在】！");
                flag = true;
            }else {
                System.out.println("当前客户在售后宝【不存在】！");
                flag = false;
            }

            System.out.println("根据客户编号查询售后宝客户是否存在（true存在；false不存在）：" + flag);
        }catch (Exception e){
            e.printStackTrace();
        }

    }

    //【售后宝人员ID】
    @Test
    public void getSHBid(){

        int pageNum = 1;
        int pageSize = 50;

        //根据售人员姓名进行匹配查询售后宝人员id
        String userName = "牧之";
        List list = new ArrayList();
        list.add(userName);

        Map map = new HashMap();
        map.put("pageNum",pageNum);
        map.put("pageSize",pageSize);
        map.put("userNameList",list);

        //根据售售后宝人员userid进行匹配查询售后宝人员信息
//        String userid = "f58e62b5-a843-11ed-bdbf-00163e179ed7";
//        List list = new ArrayList();
//        list.add(userid);
//
//        Map map = new HashMap();
//        map.put("pageNum",pageNum);
//        map.put("pageSize",pageSize);
//        map.put("userIds",list);

        String bodyStr = JSON.toJSONString(map);

        String userId = null;

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyStr);
        Request request = new Request.Builder()
                .url("https://oapi.shb.ltd/service/user/get_user_params?accessToken=f3fa69d7-b152-4e5d-9659-4208dc4c7296")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .build();

        try {
            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【人员列表】返回信息：" + responseBody);
            String substring1 = responseBody.substring(1, responseBody.length() - 1);
            log.info("去除首尾双引号后的返回信息：" + substring1);
            String substring2 = substring1.replaceAll("\\\\", "");
            log.info("去除转义字符后的返回信息：" + substring2);

            JSONObject jsonObject = JSON.parseObject(substring2);
            JSONObject data = jsonObject.getJSONObject("data");
//            System.out.println("data===" + data);

            userId = data.getJSONArray("list").getJSONObject(0).getString("userId");
            System.out.println("售后宝人员userId：" + userId);
        }catch (Exception e){
            e.printStackTrace();
        }

//        return userId;f58e62b5-a843-11ed-bdbf-00163e179ed7
    }

    //【工单类型】
    @Test
    public void getGongdanType(){
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://oapi.shb.ltd/service/task/get_task_types?accessToken=0824c173-62f3-4ad5-a2d0-dc2d03fa8e6c")
                .method("GET", null)
                .build();

        try {
            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【工单类型】返回信息：" + responseBody);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    //【创建工单】
    @Test
    public void addGongdan(){

        /*
        【创建工单json参数】
        {
            "cusNo":"KH000384",
            "cusName":"上海松江区就业促进中心",
            "address":"上海市-市辖区-松江区-荣乐东路2378号1/2/3/6楼",
            "lmName":"闻老师",
            "lmPhone":"15800656968",
            "templateId":"279bb347-913e-4627-bffc-605317774885",
            "templateName":"安装工单",
            "planTime":"2023-03-19",
            "productIds": ["a0a6c248-f5f5-11ed-ae93-00163e1537d3","4ef0ee3f-f619-11ed-996b-00163e17c56d"],
            "attribute": {
                "field_DfIX3Gg9ziTYZQpY": ["有水","有电"]
            }
        }
         */

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, "        {\n" +
                "            \"cusNo\":\"KH000384\",\n" +
                "            \"cusName\":\"上海松江区就业促进中心\",\n" +
                "            \"address\":\"上海市-市辖区-松江区-荣乐东路2378号1/2/3/6楼\",\n" +
                "            \"lmName\":\"闻老师\",\n" +
                "            \"lmPhone\":\"15800656968\",\n" +
                "            \"templateId\":\"279bb347-913e-4627-bffc-605317774885\",\n" +
                "            \"templateName\":\"安装工单\",\n" +
                "            \"planTime\":\"2023-03-19\",\n" +
                "            \"productIds\": [\"a0a6c248-f5f5-11ed-ae93-00163e1537d3\",\"4ef0ee3f-f619-11ed-996b-00163e17c56d\"],\n" +
                "            \"attribute\": {\n" +
                "                \"field_DfIX3Gg9ziTYZQpY\": [\"有水\",\"有电\"]\n" +
                "            }\n" +
                "        }");
        Request request = new Request.Builder()
                .url("https://oapi.shb.ltd/service/task/create_task_v2?accessToken=88ee3824-1fd4-4209-811f-03b9a0b5d98c")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .build();

        try {
            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【创建工单】返回信息：" + responseBody);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    //sha256加密测试
    @Test
    public void sha256test(){

        //sha256加密
        /*明文
         * timestamp毫秒级时间戳
         * */
        //当前时间的时间戳
        long timeMillis = System.currentTimeMillis();
        String timestamp = String.valueOf(timeMillis);
        log.info("当前时间的时间戳（毫秒级）：" + timestamp);

        String qingqiu = "{\"mihome\": 112,\"date\": \"2023-01-01\"}";

        /*秘钥
         * AppSecret应用秘钥
         * */
        String AppSecret = "uFW0o8ALNiwZAT9saHUD";

        //加密后的字符串
        String encodeStr= DigestUtils.sha256Hex(qingqiu + "|" + AppSecret);
        log.info("sha256加密后的字符串encodeStr：" + encodeStr);
    }

    @Test
    public void AA(){

        /*明文
         * 时间型：yyyy-MM-dd-HH
         * */
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd-HH");
        Date Date = new Date(System.currentTimeMillis());
        System.out.println("当前时间：" + Date);
        String dateNowString = simpleDateFormat.format(Date);
        System.out.println("当前时间（时间样式：yyyy-MM-dd-HH）" + dateNowString);

        /*秘钥
         * 系统id和Secret密钥
         * */
        String SystemId = "6CBAC3D3-F055-6150-E3C9-142FB65524B5";
        String secret = "c2Vhc2t5Y29udHJhY3RhcGk=";

        //加密后的字符串
        String encodeStr= DigestUtils.md5Hex(SystemId + "|" + dateNowString + "|" + secret);
        log.info("MD5加密后的字符串encodeStr：" + encodeStr);
    }

    public static com.aliyun.dingtalkyida_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkyida_1_0.Client(config);
    }

    //获取审批实例详情
    @Test
    public void getShenpi(){

        JSONObject jsonObject = null;

        int size = 100;
        int page = 1;

        do {
            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders searchFormDatasHeaders = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders();
                searchFormDatasHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest searchFormDatasRequest = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest()
                        //宜搭应用秘钥
                        .setSystemToken("RH766AC1Z0P6IBWRFIA885XCULUV275UHT5CLYF")
                        //每页查询数量
                        .setPageSize(size)
                        //当前分页
                        .setCurrentPage(page)
                        //宜搭表单ID
                        .setFormUuid("FORM-FDA66N81C5V672VY53J7D7ZBSIC63EQHRT5CL0")
                        //TODO 系统管理员id
                        .setUserId("yida_pub_account")
                        //宜搭应用编码
                        .setAppType("APP_EXJ5WMWZ18FS1F2UFOHN");

                SearchFormDatasResponse searchFormDatasResponse = client.searchFormDatasWithOptions(searchFormDatasRequest, searchFormDatasHeaders, new RuntimeOptions());
                System.out.println(JSON.toJSONString(searchFormDatasResponse.getBody()));
                String s = JSON.toJSONString(searchFormDatasResponse.getBody());
                jsonObject = JSON.parseObject(s);
                System.out.println("审批详情接口object对象：" + jsonObject);
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }

            JSONArray data = jsonObject.getJSONArray("data");
            for (int i = 0; data.size()>i; i++){

                JSONObject formData = data.getJSONObject(i).getJSONObject("formData");

                String khbh = formData.getString("textField_lhemu0bf");
                System.out.println("客户编号：" + khbh);

                String khmc = formData.getString("textField_lc5vdt71");
                System.out.println("客户名称：" + khmc);


                //客户联系人列表
                JSONArray tableField_le6s0mhc = formData.getJSONArray("tableField_le6s0mhc");
                JSONObject jsonObject1 = tableField_le6s0mhc.getJSONObject(0);
                //客户联系人姓名
                String khlxr = jsonObject1.getString("textField_lc5vdt76");
                System.out.println("客户联系人姓名：" + khlxr);
                //客户联系人电话
                String khlxrdh = jsonObject1.getString("textField_lc5vdt77");
                System.out.println("客户联系人电话：" + khlxrdh);


                String khdz = formData.getString("textField_lfj2zo84");
                System.out.println("客户地址：" + khdz);



                String khfzrmc = formData.getJSONArray("employeeField_lc5vdt7w").getString(0);
                System.out.println("客户负责人姓名：" + khfzrmc);


                /*根据客户负责人姓名来匹配售后宝的人员ID*/
                //休眠1秒后，进行调用【获取售后宝人员ID】
                try {
                    log.info("休眠中，时长为：1秒...");
                    Thread.sleep(1000);
                }catch (Exception e){
                    e.printStackTrace();
                }
                log.info("根据客户负责人姓名来匹配售后宝的人员ID===>");

                int pageNum = 1;
                int pageSize = 50;

                String userName = khfzrmc;
                List list = new ArrayList();
                list.add(userName);

                Map map = new HashMap();
                map.put("pageNum",pageNum);
                map.put("pageSize",pageSize);
                map.put("userNameList",list);

                String bodyStr = JSON.toJSONString(map);

                String userId = null;

                try {
                    OkHttpClient client = new OkHttpClient().newBuilder()
                            .build();
                    MediaType mediaType = MediaType.parse("application/json");
                    RequestBody body = RequestBody.create(mediaType, bodyStr);
                    Request request = new Request.Builder()
                            .url("https://oapi.shb.ltd/service/user/get_user_params?accessToken=6ff00058-58a9-49a3-b354-e9fb1f507f5a")
                            .method("POST", body)
                            .addHeader("Content-Type", "application/json")
                            .build();


                    Response response = client.newCall(request).execute();
                    String responseBody = response.body().string();
                    log.info("售后宝【人员列表】返回信息：" + responseBody);
                    String substring1 = responseBody.substring(1, responseBody.length() - 1);
                    log.info("去除首尾双引号后的返回信息：" + substring1);
                    String substring2 = substring1.replaceAll("\\\\", "");
                    log.info("去除转义字符后的返回信息：" + substring2);

                    JSONObject jsonObject111 = JSON.parseObject(substring2);
                    JSONObject data111 = jsonObject111.getJSONObject("data");
//            System.out.println("data===" + data);

                    userId = data111.getJSONArray("list").getJSONObject(0).getString("userId");
                    System.out.println("售后宝人员userId：" + userId);
                }catch (Exception e){
                    e.printStackTrace();
                }
                /*根据客户负责人姓名来匹配售后宝的人员ID*/


                String htqydw = formData.getString("selectField_lc5vdt7v");
                System.out.println("合同签约单位：" + htqydw);

                /*调用售后宝【客户新增】接口*/
                //封装售后宝客户新增接口需要的参数
                Map map2 = new HashMap();
                map2.put("field_2L1hdL8o2Gz563tQ",htqydw);

                Map map1 = new HashMap();
                //客户编号
                map1.put("serialNumber",khbh);
                //客户名称
                map1.put("name",khmc);
                //客户联系人
                map1.put("lmName",khlxr);
                //客户联系电话
                map1.put("lmPhone",khlxrdh);
                //客户地址
                map1.put("address",khdz);
                //客户负责人（售后宝人员id）
                map1.put("customerManager",userId);
                //客户负责人姓名
                map1.put("customerManagerName",khfzrmc);
                //合同签约单位（单选项匹配）
                map1.put("attribute",map2);

                String jsonString = JSON.toJSONString(map1);
                System.out.println("封装售后宝客户新增接口需要的参数：" + jsonString);

                //休眠1秒后，进行调用【客户新增】接口
                try {
                    log.info("休眠中，时长为：1秒...");
                    Thread.sleep(1000);
                }catch (Exception e){
                    e.printStackTrace();
                }
                log.info("调用售后宝【客户新增】接口===>");
                try {
                    OkHttpClient client = new OkHttpClient().newBuilder()
                            .build();
                    MediaType mediaType = MediaType.parse("application/json");
                    RequestBody body = RequestBody.create(mediaType, jsonString);
                    Request request = new Request.Builder()
                            .url("https://oapi.shb.ltd/service/customer/createV2?accessToken=6ff00058-58a9-49a3-b354-e9fb1f507f5a")
                            .method("POST", body)
                            .addHeader("Content-Type", "application/json")
                            .build();
                    Response response = client.newCall(request).execute();
                    String responseBody = response.body().string();
                    log.info("售后宝【客户新增】接口返回信息：" + responseBody);
                }catch (Exception e){
                    e.printStackTrace();
                }
                /*调用售后宝【客户新增】接口*/

            }

            if (data.size() == 100){
                page = page + 1;
            }

//            float aa = jsonObject.getFloat("totalCount") / 100;
//            int bb = jsonObject.getInteger("currentPage");
//            log.info("aa" + aa + "---bb" + bb);
        }while (jsonObject.getFloat("totalCount") / 100 > jsonObject.getInteger("currentPage"));


        System.out.println("同步【宜搭客户信息至售后宝】完成！");
    }

    //更新售后宝客户信息接口
    @Test
    public void updateKehu(){
        /*调用售后宝【客户更新】接口*/
        //封装售后宝客户更新接口需要的参数
//        Map map2 = new HashMap();
//        map2.put("field_2L1hdL8o2Gz563tQ",htqydw);
//
//        Map map1 = new HashMap();
//        //客户编号
//        map1.put("serialNumber",khbh);
//        //客户名称
//        map1.put("name",khmc);
//        //客户联系人
//        map1.put("lmName",khlxrStr);
//        //客户联系电话
//        map1.put("lmPhone",khlxrdhStr);
//        //客户地址
//        map1.put("address",khdz);
//        //客户负责人（售后宝人员id）
//        map1.put("customerManager",shBid);
//        //客户负责人姓名
//        map1.put("customerManagerName",khfzrxm);
//        //合同签约单位（单选项匹配）
//        map1.put("attribute",map2);

//            String jsonString = JSON.toJSONString(map1);
        String jsonString = "{\"customerNo\":\"KH20230607020507345\",\"address\":\"上海市浦东新区曹路镇AAA号\",\"lmPhone\":\"15200000000\",\"customerManager\":\"be8d91b5-85a9-11ed-b57f-00163e0b3979\",\"name\":\"测试客户名称AAA\",\"attribute\":{\"field_2L1hdL8o2Gz563tQ\":\"上海另爱实业有限公司\"},\"lmName\":\"联系人AAA\",\"customerManagerName\":\"孟慧菲\"}";//TODO 测试使用！
        System.out.println("封装售后宝客户更新接口需要的参数：" + jsonString);

        //休眠1秒后，进行调用【客户新增】接口
        try {
            log.info("休眠中，时长为：1秒...");
            Thread.sleep(1000);
        }catch (Exception e){
            e.printStackTrace();
        }
        log.info("调用售后宝【客户更新】接口===>");
        try {
            OkHttpClient client = new OkHttpClient().newBuilder()
                    .build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, jsonString);
            Request request = new Request.Builder()
                    .url("https://oapi.shb.ltd/service/customer/update_customer?accessToken=4da6f063-5083-481f-8e0a-be59d41eea40")
                    .method("POST", body)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response = client.newCall(request).execute();
            String responseBody = response.body().string();
            log.info("售后宝【客户更新】接口返回信息：" + responseBody);
        }catch (Exception e){
            e.printStackTrace();
        }
        /*调用售后宝【客户更新】接口*/
    }
}